diff --git a/game/server/src/main/java/net/minecraft/server/MinecraftServer.java b/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
index c073953af..22c248128 100644
--- a/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
+++ b/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
@@ -31,7 +31,6 @@ import net.minecraft.core.player.gamemode.Gamemodes;
 import net.minecraft.core.util.pool.ObjectPool;
 import net.minecraft.core.util.helper.UUIDHelper;
 import net.minecraft.core.world.pos.TilePos;
-import net.minecraft.core.world.save.mcregion.SaveFormat19135;
 import net.minecraft.core.world.settings.WorldConfiguration;
 import net.minecraft.core.world.type.WorldTypeGroups;
 import net.minecraft.server.entity.player.PlayerServer;
@@ -380,7 +379,11 @@ public class MinecraftServer
             }
         }
         LOGGER.info("Preparing level \"{}\"", lName);
-        initWorld(new SaveFormat19135(new File(".")), lName, randomLong);
+        ISaveFormat activeFormat = SaveFormats.createSaveFormat(CURRENT_SAVE_VERSION, new File("."));
+        if (activeFormat == null) {
+            throw new IllegalStateException("No save format registered for current save version " + CURRENT_SAVE_VERSION);
+        }
+        initWorld(activeFormat, lName, randomLong);
         LOGGER.info("Generating RSA key...");
         try
         {
@@ -467,15 +470,20 @@ public class MinecraftServer
     private void doWorldConversion(int fromVersion, String worldDirName)
     {
         ConvertProgressUpdater updater = new ConvertProgressUpdater();
-        ISaveFormat fromWorldFormat = SaveFormats.createSaveFormat(fromVersion, new File("."));
+        int currentVersion = fromVersion;
 
-        if (fromWorldFormat != null)
+        while (currentVersion < CURRENT_SAVE_VERSION)
         {
-            // Get highest converter
+            ISaveFormat fromWorldFormat = SaveFormats.createSaveFormat(currentVersion, new File("."));
+            if (fromWorldFormat == null)
+            {
+                break;
+            }
+
             ISaveConverter converterToUse = null;
             for (ISaveConverter converter : SaveConverters.saveConverters)
             {
-                if (converter.fromVersion() == fromVersion)
+                if (converter.fromVersion() == currentVersion)
                 {
                     if (converterToUse == null || converter.toVersion() > converterToUse.toVersion())
                     {
@@ -484,21 +492,50 @@ public class MinecraftServer
                 }
             }
 
-            if (converterToUse != null)
+            if (converterToUse == null)
             {
-                ISaveFormat toWorldFormat = SaveFormats.createSaveFormat(converterToUse.toVersion(), new File("."));
+                break;
+            }
+            if (converterToUse.toVersion() <= currentVersion)
+            {
+                LOGGER.warn("World conversion halted for '{}' due to non-advancing converter {} -> {}.", worldDirName, converterToUse.fromVersion(), converterToUse.toVersion());
+                break;
+            }
 
-                if (toWorldFormat != null)
-                {
-                    CompoundTag levelDataTag = toWorldFormat.getLevelDataRaw(worldDirName);
+            ISaveFormat toWorldFormat = SaveFormats.createSaveFormat(converterToUse.toVersion(), new File("."));
+            if (toWorldFormat == null)
+            {
+                break;
+            }
 
-                    converterToUse.convertSave(levelDataTag, new File("."), worldDirName, updater);
+            CompoundTag levelDataTag = toWorldFormat.getLevelDataRaw(worldDirName);
 
-                    levelDataTag.putInt("version", toWorldFormat.getSaveVersion());
+            converterToUse.convertSave(levelDataTag, new File("."), worldDirName, updater);
 
-                    LevelStorage saveHandler = toWorldFormat.getLevelStorage(worldDirName, false);
-                    saveHandler.saveLevelDataRaw(levelDataTag);
-                }
+            levelDataTag.putInt("version", toWorldFormat.getSaveVersion());
+
+            LevelStorage saveHandler = toWorldFormat.getLevelStorage(worldDirName, false);
+            saveHandler.saveLevelDataRaw(levelDataTag);
+
+            CompoundTag reloadedLevelData = toWorldFormat.getLevelDataRaw(worldDirName);
+            int reloadedVersion = reloadedLevelData != null ? reloadedLevelData.getInteger("version") : -1;
+            if (reloadedVersion < toWorldFormat.getSaveVersion())
+            {
+                LOGGER.warn("World conversion write verification failed for '{}' (expected >= {}, got {}).", worldDirName, toWorldFormat.getSaveVersion(), reloadedVersion);
+                break;
+            }
+
+            currentVersion = reloadedVersion;
+        }
+
+        ISaveFormat currentFormat = SaveFormats.createSaveFormat(CURRENT_SAVE_VERSION, new File("."));
+        if (currentFormat != null)
+        {
+            CompoundTag finalLevelData = currentFormat.getLevelDataRaw(worldDirName);
+            if (finalLevelData != null && finalLevelData.getInteger("version") < CURRENT_SAVE_VERSION)
+            {
+                finalLevelData.putInt("version", CURRENT_SAVE_VERSION);
+                currentFormat.getLevelStorage(worldDirName, false).saveLevelDataRaw(finalLevelData);
             }
         }
 
diff --git a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
index 50656deab..ae46c6d71 100644
--- a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
@@ -67,13 +67,13 @@ class WorkbenchGenerator {
         generateMiscNewRecipes();
 
         RecipeBuilder.Shaped(CORE_NAMESPACE)
-                .setShape(
-                    "CCW",
-                    "PPP")
-                .addInput('C', Items.CLOTH)
-                .addInput('W', "minecraft:wools")
-                .addInput('P', "minecraft:planks")
-                .create("bed", Items.BED.getDefaultStack());
+            .setShape(
+                "CCW",
+                "PPP")
+            .addInput('C', Items.CLOTH)
+            .addInput('W', "minecraft:wools")
+            .addInput('P', "minecraft:planks")
+            .create("bed", Items.BED.getDefaultStack());
 
         RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
@@ -84,13 +84,13 @@ class WorkbenchGenerator {
             .create("seat", Items.SEAT.getDefaultStack());
 
         RecipeBuilder.Shaped(CORE_NAMESPACE)
-                .setShape(
-                    "###",
-                    "X X",
-                    "XXX")
-                .addInput('#', Items.LEATHER)
-                .addInput('X', Items.WHEAT)
-                .create("basket", Items.BASKET.getDefaultStack());
+            .setShape(
+                "###",
+                "X X",
+                "XXX")
+            .addInput('#', Items.LEATHER)
+            .addInput('X', Items.WHEAT)
+            .create("basket", Items.BASKET.getDefaultStack());
 
         RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
@@ -1340,7 +1340,7 @@ class WorkbenchGenerator {
             .create("tnt", new ItemStack(Blocks.TNT));
 
         RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput("minecraft:stones").create("stone_button", new ItemStack(Blocks.BUTTON_STONE, 4));
-        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.PLANKS_OAK).create("wooden_button", new ItemStack(Blocks.BUTTON_PLANKS, 4));
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.PLANKS_OAK).create("wooden_button", new ItemStack(Blocks.BUTTON_PLANKS_OAK, 4));
         for (DyeColor color : DyeColor.values()) {
             RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.PLANKS_OAK_PAINTED, color.blockMeta).create(color.colorID + "_wooden_button", new ItemStack(Blocks.BUTTON_PLANKS_PAINTED, 4, color.blockMeta << 4));
         }
@@ -1517,7 +1517,7 @@ class WorkbenchGenerator {
         Registries.RECIPES.WORKBENCH.register(String.format(format, "lamps"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:lamps"), new ItemStack(Blocks.LAMP_IDLE)));
         Registries.RECIPES.WORKBENCH.register(String.format(format, "wools"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:wools"), new ItemStack(Blocks.WOOL)));
         Registries.RECIPES.WORKBENCH.register(String.format(format, "chests"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:chests"), new ItemStack(Blocks.CHEST_PLANKS_OAK)));
-        Registries.RECIPES.WORKBENCH.register(String.format(format, "buttons_planks"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:button_planks"), new ItemStack(Blocks.BUTTON_PLANKS)));
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "buttons_planks"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:button_planks"), new ItemStack(Blocks.BUTTON_PLANKS_OAK)));
         Registries.RECIPES.WORKBENCH.register(String.format(format, "pressureplates_planks"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:pressureplates_planks"), new ItemStack(Blocks.PRESSURE_PLATE_PLANKS_OAK)));
     }
 
@@ -1540,18 +1540,6 @@ class WorkbenchGenerator {
     }
 
     private static void generateMiscNewRecipes() {
-        // Carved Stones
-        RecipeBuilderShaped templateCarvedStone = RecipeBuilder.Shaped(CORE_NAMESPACE).setShape("SS", "SS");
-        templateCarvedStone.addInput('S', Blocks.STONE_POLISHED).create("carved_stone", new ItemStack(Blocks.STONE_CARVED, 2));
-        templateCarvedStone.addInput('S', Blocks.BASALT_POLISHED).create("carved_basalt", new ItemStack(Blocks.BASALT_CARVED, 2));
-        templateCarvedStone.addInput('S', Blocks.LIMESTONE_POLISHED).create("carved_limestone", new ItemStack(Blocks.LIMESTONE_CARVED, 2));
-        templateCarvedStone.addInput('S', Blocks.GRANITE_POLISHED).create("carved_granite", new ItemStack(Blocks.GRANITE_CARVED, 2));
-        templateCarvedStone.addInput('S', Blocks.PERMAFROST_POLISHED).create("carved_permafrost", new ItemStack(Blocks.PERMAFROST_CARVED, 2));
-        templateCarvedStone.addInput('S', Blocks.MARBLE).create("marble_capstone", new ItemStack(Blocks.CAPSTONE_MARBLE, 2));
-        templateCarvedStone.addInput('S', Blocks.SLATE_POLISHED).create("carved_slate", new ItemStack(Blocks.SLATE_CARVED, 2));
-        templateCarvedStone.addInput('S', Blocks.NETHERRACK_POLISHED).create("carved_netherrack", new ItemStack(Blocks.NETHERRACK_CARVED, 2));
-        templateCarvedStone.addInput('S', Blocks.GLOOMSTONE_POLISHED).create("carved_gloomstone", new ItemStack(Blocks.GLOOMSTONE_CARVED, 2));
-
         // Brimstone Formatting
         RecipeBuilder.Shaped(CORE_NAMESPACE).setShape("SS", "SS").addInput('S', Blocks.BRIMSAND).create("brimstone", new ItemStack(Blocks.BRIMSTONE, 2));
         RecipeBuilder.Shaped(CORE_NAMESPACE).setShape("SSS").addInput('S', Blocks.BRIMSTONE).create("brimstone_slab", new ItemStack(Blocks.SLAB_BRIMSTONE, 6));
@@ -1569,6 +1557,68 @@ class WorkbenchGenerator {
         RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.LOG_SCORCHED).create("scorched_log_to_black_wooden_planks", new ItemStack(Blocks.PLANKS_OAK_PAINTED, 4, 15));
     }
 
+    /**
+     * Unused carved stone recipes
+     */
+    @SuppressWarnings("unused")
+    private static void generateCarvedStoneRecipesDisabled() {
+        RecipeBuilderShaped templateCarvedStone = RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "   ",
+                "SSS",
+                "SSS");
+        templateCarvedStone.addInput('S', Blocks.STONE_POLISHED).create("carved_stone", new ItemStack(Blocks.STONE_CARVED, 6));
+        templateCarvedStone.addInput('S', Blocks.BASALT_POLISHED).create("carved_basalt", new ItemStack(Blocks.BASALT_CARVED, 6));
+        templateCarvedStone.addInput('S', Blocks.LIMESTONE_POLISHED).create("carved_limestone", new ItemStack(Blocks.LIMESTONE_CARVED, 6));
+        templateCarvedStone.addInput('S', Blocks.GRANITE_POLISHED).create("carved_granite", new ItemStack(Blocks.GRANITE_CARVED, 6));
+        templateCarvedStone.addInput('S', Blocks.PERMAFROST_POLISHED).create("carved_permafrost", new ItemStack(Blocks.PERMAFROST_CARVED, 6));
+        RecipeBuilder.Shaped(CORE_NAMESPACE).setShape("SS", "SS")
+            .addInput('S', Blocks.MARBLE).create("marble_capstone", new ItemStack(Blocks.CAPSTONE_MARBLE, 2));
+        templateCarvedStone.addInput('S', Blocks.SLATE_POLISHED).create("carved_slate", new ItemStack(Blocks.SLATE_CARVED, 6));
+        templateCarvedStone.addInput('S', Blocks.NETHERRACK_POLISHED).create("carved_netherrack", new ItemStack(Blocks.NETHERRACK_CARVED, 6));
+        templateCarvedStone.addInput('S', Blocks.GLOOMSTONE_POLISHED).create("carved_gloomstone", new ItemStack(Blocks.GLOOMSTONE_CARVED, 6));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape("SSS")
+            .addInput('S', Blocks.STONE_CARVED)
+            .create("stone_carved_to_slab", new ItemStack(Blocks.SLAB_STONE_POLISHED, 6));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape("SSS")
+            .addInput('S', Blocks.BASALT_CARVED)
+            .create("basalt_carved_to_slab", new ItemStack(Blocks.SLAB_BASALT_POLISHED, 6));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape("SSS")
+            .addInput('S', Blocks.LIMESTONE_CARVED)
+            .create("limestone_carved_to_slab", new ItemStack(Blocks.SLAB_LIMESTONE_POLISHED, 6));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape("SSS")
+            .addInput('S', Blocks.GRANITE_CARVED)
+            .create("granite_carved_to_slab", new ItemStack(Blocks.SLAB_GRANITE_POLISHED, 6));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape("SSS")
+            .addInput('S', Blocks.PERMAFROST_CARVED)
+            .create("permafrost_carved_to_slab", new ItemStack(Blocks.SLAB_PERMAFROST_POLISHED, 6));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape("SSS")
+            .addInput('S', Blocks.SLATE_CARVED)
+            .create("slate_carved_to_slab", new ItemStack(Blocks.SLAB_SLATE_POLISHED, 6));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape("SSS")
+            .addInput('S', Blocks.NETHERRACK_CARVED)
+            .create("netherrack_carved_to_slab", new ItemStack(Blocks.SLAB_NETHERRACK_POLISHED, 6));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape("SSS")
+            .addInput('S', Blocks.GLOOMSTONE_CARVED)
+            .create("gloomstone_carved_to_slab", new ItemStack(Blocks.SLAB_GLOOMSTONE_POLISHED, 6));
+    }
+
     private static void generateAcidConversions() {
         // Each pair: { input, output }
         final Block<?>[][] pairs = {
